<?php
namespace Service;

use Doctrine\ORM\EntityManager;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Zeedhi\DevOps\Model\Projectmanagement\Repositories;
use \Util\Utilities;
use Zeedhi\DevOps\Util\Utilities as DevUtil;
use \Factory;

class ProjectTypeByProfile
{
    /** @var Repositories\Project */
    protected $projectRepository;

    /**
     * @var EntityManager $entityManager
     */
    private $entityManager;

    /**
     * @var Utilities $utilities
     */
    private $utilities;    


     /** @var Repositories\ProjectType */
    protected $projectTypeRepository;
   
    public function __construct(EntityManager $entityManager, \Util\Utilities $utilities){
        $this->entityManager = $entityManager;
        $this->utilities = $utilities;
        $this->projectTypeRepository = $this->entityManager->getRepository(Utilities::ENTITY_DIR . 'ProjectType');
        $this->projectRepository = $this->entityManager->getRepository(Utilities::ENTITY_DIR . 'Project');
    }

    public function getProjectTypeByProfile($organization, $profiles,$filters,$projectParentId = null){
        $profiles ? $profiles = DevUtil::getStringForArray($profiles) : 0;
        $hasProduct = false;
        if($projectParentId){
            /** @var Entities\Project $project */
            $project = $this->projectRepository->find($projectParentId);
            $hasProduct = !!Project::getProductOrModelProject($project);
        }
        return $this->projectTypeRepository->getProjectTypeByProfile($organization, $profiles,$filters,$hasProduct);
    }

    public function findProjectTypesForProjectFilter(){

        $organization = $this->utilities->getCurrentOrganizationId();
        return $this->projectTypeRepository->getProjectTypesForProjectFilter($organization);
    }

}
