<?php
namespace Util;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Util\Instance\Service as InstanceService;
use Util\Instance\Repository as InstanceRepository;
use Util\Instance\Factory as InstanceFactory;

class InstanceProvider {
    
    public static function getService()
    {
        return InstanceService::getInstance();
    }

    /** @return \Util\Instance\Repository */
    public static function getRepository()
    {
        return InstanceRepository::getInstance();
    }
    
    public static function getFactory()
    {
        return InstanceFactory::getInstance();
    }
    
    /** @return \Util\Utilities */
    public static function getEnvironment()
    {
        return InstanceManager::getInstance()->getService('\Util\Utilities');
    }

    /** @return \Util\Log */
    public static function getLog()
    {
        return InstanceManager::getInstance()->getService('\Util\Log');
    }
    
    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }
    
    /** @return \Teknisa\Libs\Controller\Api */
    public static function getLibsControllerApi()
    {
        return InstanceManager::getInstance()->getService('\Teknisa\Libs\Controller\Api');
    }
    
     /** @return \Teknisa\Libs\Util\NewCode */
    public static function getNewCode() {
        return InstanceManager::getInstance()->getService('newCodeSC');
    }

    /** @return \Teknisa\Libs\Util\Utilities */
    public static function getLibsUtilities()
    {
        return InstanceManager::getInstance()->getService('libUtilities');
    }

    /** @return  \Util\Mail\IssueMail */
    public static function getMailIssueMail()
    {
        return InstanceManager::getInstance()->getService('\Util\Mail\IssueMail');
    }

    /** @return  \Zeedhi\Framework\HTTP\Kernel */
    public static function getZeedhiFrameworkHTTPKernel()
    {
        return InstanceManager::getInstance()->getService('kernel');
    }

    /** @return  \Zeedhi\Framework\Session\Session */
    public static function getSession()
    {
        return InstanceManager::getInstance()->getService('session');
    }

    /** @return \Controller\Task */
    public static function getTaskController()
    {
        return InstanceManager::getInstance()->getService('\Controller\Task');
    }
}