create or replace PROCEDURE PLANOCONTA_DIAAUXILIAR_492(
   P_CDEMPRESA    IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_DTINICIAL    IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL      IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_NRSEQARQMAG  IN ARQMAGNETICO.NRSEQARQMAG%TYPE)
AS
   V_SEQUNCIAL    NUMBER;
   V_IDTIPOCONT   VARCHAR2(01);
   V_CDCONTCTBL   VARCHAR2(20);
   V_NMCONTCTBL   VARCHAR2(100);
   V_DSREGISTRO   VARCHAR2(5000);
   V_DTCTBL       DATE;
BEGIN
   FOR C_PLANOCONTA_DIAAUXILIAR IN (SELECT DISTINCT IDLANCCOME AS IDLANC,
                                                    CDCONTCOME AS CDORIGEM
                                          FROM LANCCONT L, FORNECEDOR F
                                          WHERE L.IDLANCCOME = 'F'  AND
                                                L.DTLANCCONT BETWEEN P_DTINICIAL AND P_DTFINAL AND
                                                F.CDFORNECED = L.CDCONTCOME
                                          UNION ALL
                                          SELECT DISTINCT IDLANCCOME AS IDLANC,
                                                          CDCONTCOME AS CDORIGEM
                                          FROM LANCCONT L, CLIENTE C
                                          WHERE L.IDLANCCOME = 'C'  AND
                                                L.DTLANCCONT BETWEEN P_DTINICIAL AND P_DTFINAL AND
                                                C.CDCLIENTE = L.CDCONTCOME
                                          UNION ALL
                                          SELECT DISTINCT IDLANCCOME AS IDLANC,
                                                          CDCONTCOME AS CDORIGEM
                                          FROM LANCCONT L, CONTCORR C
                                          WHERE L.IDLANCCOME = 'B'  AND
                                                L.DTLANCCONT BETWEEN P_DTINICIAL AND P_DTFINAL AND
                                                C.CDREDUCONT = L.CDCONTCOME) LOOP
      /* busca a conta contbil do fornecedor primeiro na tabela FORNECEDOR, PARAMEMPRESA e CONTCTBL*/
      IF (C_PLANOCONTA_DIAAUXILIAR.IDLANC = 'F') THEN
         BEGIN
            SELECT CDCONTCTBL
            INTO V_CDCONTCTBL
            FROM FORNECEDOR
            WHERE CDFORNECED = C_PLANOCONTA_DIAAUXILIAR.CDORIGEM;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
                V_CDCONTCTBL := NULL;
         END;
         IF (V_CDCONTCTBL IS NULL) THEN
            BEGIN
               SELECT CDCONFORNEM
               INTO V_CDCONTCTBL
               FROM PARAMEMPRESA
               WHERE CDEMPRESA = P_CDEMPRESA;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCONTCTBL := NULL;
            END;
         END IF;
         IF (V_CDCONTCTBL IS NULL) THEN
            BEGIN
               SELECT CDCONTFORN
               INTO V_CDCONTCTBL
               FROM PARAMCTBL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCONTCTBL := NULL;
            END;
         END IF;
      END IF;
      /* busca a conta contbil do cliente primeiro na tabela CLIENTE, PARAMEMPRESA e CONTCTBL*/
      IF (C_PLANOCONTA_DIAAUXILIAR.IDLANC = 'C') THEN
         BEGIN
            SELECT CDCONTCTBL
            INTO V_CDCONTCTBL
            FROM CLIENTE
            WHERE CDCLIENTE = C_PLANOCONTA_DIAAUXILIAR.CDORIGEM;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTCTBL := NULL;
         END;
         IF (V_CDCONTCTBL IS NULL) THEN
            BEGIN
               SELECT CDCONCLIEEM
               INTO V_CDCONTCTBL
               FROM PARAMEMPRESA
               WHERE CDEMPRESA = P_CDEMPRESA;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCONTCTBL := NULL;
            END;
         END IF;
         IF (V_CDCONTCTBL IS NULL) THEN
            BEGIN
               SELECT CDCONTCLIE
               INTO V_CDCONTCTBL
               FROM PARAMCTBL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCONTCTBL := NULL;
            END;
         END IF;
      END IF;
      /* busca a conta contbil do banco primeiro somente na tabela CONTCORR*/
      IF (C_PLANOCONTA_DIAAUXILIAR.IDLANC = 'B') THEN
         BEGIN
            SELECT CDCONTCTBL
            INTO V_CDCONTCTBL
            FROM CONTCORR
            WHERE CDREDUCONT = C_PLANOCONTA_DIAAUXILIAR.CDORIGEM;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDCONTCTBL := NULL;
         END;
      END IF;
      BEGIN
         SELECT DTULTATUCCTB,
                IDTIPOCONT,
                NMCONTCTBL
         INTO V_DTCTBL, V_IDTIPOCONT, V_NMCONTCTBL
         FROM CONTCTBL
         WHERE CDCONTCTBL = V_CDCONTCTBL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTCTBL     := NULL;
            V_IDTIPOCONT := NULL;
            V_NMCONTCTBL := NULL;
      END;
      V_DSREGISTRO := TO_CHAR(NVL(V_DTCTBL,SYSDATE), 'DDMMYYYY')||
                      RPAD(NVL(SUBSTR(REPLACE(REPLACE(REPLACE(C_PLANOCONTA_DIAAUXILIAR.CDORIGEM,'/',''),'-',''),'.',''),2,28),' '), 28, ' ')||
                      NVL(V_IDTIPOCONT,' ')||
                      RPAD(NVL(V_CDCONTCTBL,' '), 28, ' ')||
                      RPAD(NVL(V_NMCONTCTBL,' '), 45, ' ');
      V_SEQUNCIAL := NVL(V_SEQUNCIAL,0) +1;
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('08'||LPAD(RTRIM(V_SEQUNCIAL), 8, '0'), V_DSREGISTRO,  P_NRSEQARQMAG);
   END LOOP;
END;
/
-- VERSAO --
BEGIN ATUVEROBJ('PLANOCONTA_DIAAUXILIAR_492','5.33.xxx'); END;
/