<?php
namespace Zeedhi\Tools\EntityGenerator;

use Zeedhi\Tools\DatabaseReader\DTO\Column;
use Zeedhi\Tools\Holder\EntityField;

class TypeConverter {

    public static $typesEquivalenceTable = array(
        Column::DATA_TYPE_BINARY       => EntityField::TYPE_BLOB,
        Column::DATA_TYPE_CLOB         => EntityField::TYPE_TEXT,
        Column::DATA_TYPE_BOOLEAN      => EntityField::TYPE_BOOLEAN,
        Column::DATA_TYPE_DATE         => EntityField::TYPE_DATE,
        Column::DATA_TYPE_DATETIME     => EntityField::TYPE_DATETIME,
        Column::DATA_TYPE_FLOAT        => EntityField::TYPE_FLOAT,
        Column::DATA_TYPE_INTEGER      => EntityField::TYPE_INTEGER,
        Column::DATA_TYPE_STRING       => EntityField::TYPE_STRING,
        Column::DATA_TYPE_STRING_FIXED => EntityField::TYPE_STRING
    );

    public static $defaultValuesEquivalenceTable = array(
        "SYSDATE" => EntityField::DEFAULT_VALUE_CURRENT_DATE,
        "sysdate" => EntityField::DEFAULT_VALUE_CURRENT_DATE,
        "NULL" => EntityField::DEFAULT_VALUE_NULL
    );

    public static function defaultValueFromMetadata($value){
        $value = trim($value);
        if (isset(self::$defaultValuesEquivalenceTable[$value])) {
            return self::$defaultValuesEquivalenceTable[$value];
        } else {
            return $value;
        }
    }

    public static function typeFromMetadata($value){
        return self::$typesEquivalenceTable[$value];
    }

} 